function R = Rectangles(s,l1)
%%%Given a string s it returns all the (oriented) rectangles as follows:
%%%Each rectangle corresponds to a vector [position1, sign1, position2, sign2]
%%%where the position(1/2) determine the position of the letter and the
%%%signs determine the sign of the letter.
%%%If l1=0 then it just computes positively oriented rectangles, suitable
%%%for computing scl.
R = [0,0,0,0];
for i=1:length(s) %%%first letter
    for j=(i+1):length(s) %%%second letter, has to be different
        if lower(s(i)) == lower(s(j)) %%we've got two letters of the same type
            if s(i) ~= s(j) %%sign of the letters is different
                r_temp = [i,1,j,1];
                R = [R;r_temp];
                if l1 ~= 0 %%%CONTINUE SETTING UP THE RECTANGLE
                    r_temp = [i,-1,j,-1];
                    R = [R;r_temp];
                end
            end
            if s(i) == s(j) & l1 ~= 0  %%sign of the letters is the same!
                   r_temp = [i,1,j,-1];
                   R = [R;r_temp];
                   r_temp = [i,-1,j,1];
                   R = [R;r_temp];     
            end
        end
    end
end 

R = R(2:end,:);
end

