function [l1_bound,x,Aequ,bequ, R, RP, Bipod, Tripod, o_Tripod, do_Tripod] = lallop_arbitarary_vertex(s,l1,verbose,degree4)
tic
wordlength=length(s);
%%%%computes a lower bound of l1 norm or the stable commutator length.
%%%%degree4: allows to just compute surfaces where each vertex has maximal
%%%%degree 4.
if verbose > 0 
    fprintf('length of input: %2i \n', length(s))
    fprintf('Generating Rectangles \n')
end
toc
R = Rectangles(s,l1);
s_rect = size(R);
l_rectangles = s_rect(1);

if verbose > 0 
    fprintf('Generated Rectangles. Total number: %i \n', l_rectangles)
    fprintf('Generating Bipods \n')
end
toc

Bipod = Bipods(R,wordlength);
s_bipods = length(Bipod);

if verbose > 0 
    fprintf('Generated Bipods. Total number: %i \n', s_bipods)
    fprintf('Generating Tripods \n')
end
toc

Tripod = Tripods(R,wordlength);
s_tripods = length(Tripod);


if verbose > 0 
    fprintf('Generated Tripods. Total number: %i \n', s_tripods)
    fprintf('Generating Rectangle Pairs \n')
end
toc

RP = Rectangle_Pairs(R,wordlength);
s_rp = length(RP);


if verbose > 0 
    fprintf('Generated Rectangle Pairs. Total number: %i \n', s_rp)
    fprintf('Generating Open Tripods \n')
end
toc

o_Tripod = open_tripods(R,RP,wordlength);
s_o_tripod = length(o_Tripod);

if verbose > 0 
    fprintf('Generated Open Tripods. Total number: %i \n', s_o_tripod) 
end
toc


if degree4==0
    if verbose > 0
        fprintf('Generating Double Open Tripods \n')
    end
do_Tripod = dopen_Tripods(R,RP,wordlength);
s_do_Tripod = length(do_Tripod);
if verbose > 0 
    fprintf('Generated Double Open Tripods. Total number: %i \n', s_do_Tripod)
end
else 
        do_Tripod = [NaN, NaN, NaN, NaN]; %%% setting o_Quadropod to be absurd if degree4==1
end

if verbose > 0
    fprintf('Setting up the linear programming problem \n')
end
toc

[l_max,Aequ,bequ,lb]= Linear_Programming_Problem(R,RP,Bipod,Tripod,o_Tripod,do_Tripod,wordlength,l1,degree4);

if verbose > 0 
    fprintf('Matrixes for Linear Programming Problem Generated \n')
    fprintf('Solving the Linear Programming Problem')
end
toc

[x,fval] = intlinprog(l_max,[],[],[],Aequ,bequ,lb,[],[]);

if l1==1
    l1_bound = 2*fval;
else
    l1_bound = fval/2;
end

if verbose > 0 
    if l1~= 0
        fprintf('Lower l1-bound of %s is %s \n',s, strtrim(rats(l1_bound)))
    else
        fprintf('scl of %s is %s \n', s, strtrim(rats(l1_bound)))
    end
end

end